DivestOS/Container/phase-1.sh

45 lines
1.4 KiB
Bash
Raw Normal View History

Container: Scripted builds I had a hard time following the [Build Guide](https://divestos.org/pages/build) and IMO a script does a much better job of removing the ambiguity and is more likely to be updated if it fails. Per https://github.com/Divested-Mobile/DivestOS-Website/issues/40 I think this script, as documentation, makes it much more clear what it means to "color in the lines" and suggests an efficient way of doing so. I'd like to update the Build Guide too, but I wanted to get your feedback on some of this first. The main thing I'm not thrilled with is that the workspace needs to be patched and reset twice (if I understand correctly). I got this notion from your guidance on a Reddit post a couple months back which I can't find now that Reddit seems to have taken down your content. Unfortunately I don't recall the details but the basic issue is that generating the signing keys was giving an error and the solution was to patch the workspace. But one of the workspace patching "phases" is to copy the keys to the kernel and this fails if the keys don't exist yet. So it's not clear how to get around doing this step twice. A couple notes on future work: - How to do incremental updates? There's no story on this yet and I haven't looked into it. - I found a wealth of information on building android in docker in this repository: https://github.com/lineageos4microg/docker-lineage-cicd. It might be worth considering trying to integrate DivestOS into that project or building on top of their image.
2024-07-26 21:30:33 +00:00
#!/usr/bin/env bash
version="$1" # (e.g. "20.0")
if [ "$1" = "" ]; then
echo "Missing arguments"
exit 1
fi
# Correctness
set -exo pipefail
umask 0022
# Clone
git clone https://codeberg.org/divested-mobile/divestos-build.git DivestOS
cd DivestOS
# Submodules
sed -i 's|git@gitlab.com:|https://gitlab.com/|' .git/config .gitmodules
git submodule update --init --recursive
# Basic directories
mkdir -p "Build/LineageOS-$version/.repo/local_manifests" Builds Signing_Keys .Signing_Keys
# Encrypted key storage
# TODO There is probably an alternative to gocryptfs which doesn't require a security
# trade-off between giving the container more privileges and encrypting the keys.
if modprobe fuse; then
gocryptfs -init .Signing_Keys
gocryptfs .Signing_Keys/ Signing_Keys/
else
echo "WARNING: gocryptfs failed. Signing keys will not be encrypted!"
fi
# Update paths
# https://backreference.org/2009/12/09/using-shell-variables-in-sed/index.html
safe_pattern=$(printf '%s\n' "$(pwd)" | sed 's/[[\.*^$/]/\\&/g')
sed -i "s/\(^export DOS_WORKSPACE_ROOT=\).*/\1\"$safe_pattern\"/" Scripts/init.sh
safe_pattern=$(printf '%s\n' "$(pwd)/Builds" | sed 's/[[\.*^$/]/\\&/g')
sed -i "s/\(^export DOS_BUILDS=\).*/\1\"$safe_pattern\"/" Scripts/init.sh
# Add the initial manifest
cd "Build/LineageOS-$version/"
cat "../../Manifests/Manifest_LAOS-$version.xml" > .repo/local_manifests/local_manifest.xml